<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Contaraseña Java</title>
    <script>
        Program()
        function Program()
        {
            do{
                var password = prompt("Escriu una contrasenya"); 
            }while(PasswordCheck(password) == false)
            alert("La teva contrasenya es correcte i valida!!");
        }
        
        
        function PasswordCheck(password)
        {
            let password2 = password.trim();
            if(password2.length >= 8 && password2.length <=20)
            {
                var contadorMayus = 0;
                var contadorMinus = 0;
                var contadorNums = 0;
                for(var i = 0; i < password2.length;i++)
                {
                    if(password2.charCodeAt(i) >= 65 && password2.charCodeAt(i) <= 90)contadorMayus++;
                    if(password2.charCodeAt(i) >= 97 && password2.charCodeAt(i) <= 122)contadorMinus++;
                    if(password2.charCodeAt(i) >= 48 && password2.charCodeAt(i) <= 57)contadorNums++;
                }
                
                if(contadorMayus >= 1 && contadorMinus >= 3 && contadorNums >=2 && FollowingChars(password2) == true) return true;
                else if(contadorMayus < 1 || contadorMinus < 3 || contadorNums <2){
                    alert("La contraseña debe tener 3 misnusculas, 1 mayuscula y 2 numeros");
                    return false;
                }
            }
               
            else{
                alert("La contrasenya te que ser mes gran de 8 y mes petita que 20");
                return false;
            }
        }
        function FollowingChars(password2)
        {
            for(var i = 0; i < password2.length - 2;i++)
            {
                if(password2.charAt(i) == password2.charAt(i+1) && password2.charAt(i+2) == password2.charAt(i)){
                    alert("Es repteixen una serie de 3 caracters seguits, no es valid."); 
                    return false;                  
                }
            }
            return true;
        }
    </script>
</head>
<body>
    
</body>
</html>